//-----------------------------------------------------------------------------------------
//	TexitEngine.cpp
//-----------------------------------------------------------------------------------------

#include	<windows.h>
#include	"BasicTips.h"
#include	"g_tool.h"
#include	"main.h"
#include	"TextEngine.h"
#include	"Text_Com_01.h"
#include	"Text_Com_02.h"


//###################################################################
//	sdwsGW
//###################################################################

//   񂿂
//	SHIFT JIS R[h́APoCg 80h ȏłB	
//	{ } / ; ̃ViIt@C䕶́Aׂ		
//	80h ̃R[hł̂ŁASpƋꍇ
//	KQoCgƂԂ邱ƂɂȂB āA	
//	ꂪpSp̔́A{ } / ; 	
//	ꍇ̒ÔPoCg 80h ȏォǂ	
//	ōsȂƂłB80hȏȂSpA80hȉȂ	
//	pŐΏۂƂȂB	

unsigned char	TEXT_BUF[SIZE_OF_TEXT_BUF];	//XNvgǂݍރGA

unsigned char	*TEXT;	//Text pointerieLXg߈ʒu|Cg܂j

int		Font_Size;	//tHgTCY

int		TEXT_WAIT;		//P\̃EFCg
RECT	TEXT_AREA;		//eLXgWJʗ̈
int		TEXT_X;			//݂̕\ʒuw
int		TEXT_Y;			//݂̕\ʒux
int		TEXT_X_PITCH;	//sb`w
int		TEXT_Y_PITCH;	//sb`x

DWORD	TEXT_TIMER;		//^C}[

//-------------------------------------
//	TEXTGW
//-------------------------------------

void _Set_Default_params()
	//ftHgp[^̐ݒ
{	
	int		i;

	TEXT_WAIT = 30;			//P\̃EFCg(ms)
	Font_Size = 20;				//Font size

	TEXT_AREA.left	= 20;		//eLXg\GAijł640*480̉ʒ[ꗥ20hbgɐݒ肵Ă܂
	TEXT_AREA.top	= 20;		//eLXg\GAij
	TEXT_AREA.right	= 640-20;	//eLXg\GAiEj
	TEXT_AREA.bottom= 480-20;	//eLXg\GAij

	TEXT_X=TEXT_AREA.left;			//ʒuJE^i\GAn܂j	
	TEXT_Y=TEXT_AREA.top;		

	TEXT_X_PITCH = Font_Size/2;					//sb`iwj
	TEXT_Y_PITCH = Font_Size*130/100;			//sb`ixj

	//CxgtO̓[NA
	for( i=0;i<EVENT_FLAG_MAX;i++){
		Mode_stat.event_flag[i]=0;
	}
}

void Init_Text_engine()
	//CjVCÝuev֐
{
	char	str[256];

	TEXT=TEXT_BUF;	//eLXg|C^TEXTobt@擪ɃZbg

	//ftHg̃XNvgt@Cǂ
	strcpy( str,TEXT_PATH );
	strcat( str,"default.txt");
	HLS_bload(str,(char *)TEXT_BUF);

	_Set_Default_params();			//ftHgp[^̐ݒ

	HLS_timer_start(&TEXT_TIMER);	//^C}[X^[g
}

//-------------------------------------
//	ʒũCNg
//-------------------------------------

void Increment_textp_pos(int inc)	
	//\ʒũCNg
	//	int incFbyteCNg邩Por2
{
	//ŏIsłāAȂE[|PځiJ[\uNʒum ^^j
	//̏ꍇ́uy[WvɂĂ܂B
	if( (TEXT_Y+TEXT_Y_PITCH)>=(TEXT_AREA.bottom-TEXT_Y_PITCH) &&
		(TEXT_X+TEXT_X_PITCH*inc)>=(TEXT_AREA.right-TEXT_X_PITCH*4) ){

		//J[\ʒuWQƂĂ̂łƂ肠CNg
		TEXT_X += TEXT_X_PITCH*inc;	

		Com_page2();	//y[W type2
		return;
	}

	//ȉ͉y[W͍lȂ͈͂ł̘b

	if( (TEXT_X+TEXT_X_PITCH*inc) < (TEXT_AREA.right-TEXT_X_PITCH*2) ){
		//s[ɒBĂȂꍇ͒PɂwWP₷
		TEXT_X += TEXT_X_PITCH*inc;
	}else{
		//s[ł͉s
		TEXT_X =  TEXT_AREA.left;
		TEXT_Y += TEXT_Y_PITCH;
	}

}

//-------------------------------------
//	POieLXg̉
//-------------------------------------

int kaiseki_10()
	// 10ieLXg̉
{
	int		val=0;
	int		flag=0;
	int		fugo=1;	//łi΁j
	char	buf[40],str[256];
	int		i;

	while( *TEXT<=' ' ) TEXT++;	//󔒂ǂݔ΂

	do{
		switch( *TEXT ){
			case	'-':	fugo=-1;break;	//rŏoĂĂ}CiXioǑȁ[ ^^;j
			case	'0':	val+=0;	break;
			case	'1':	val+=1;	break;
			case	'2':	val+=2;	break;		
			case	'3':	val+=3;	break;		
			case	'4':	val+=4;	break;		
			case	'5':	val+=5;	break;		
			case	'6':	val+=6;	break;		
			case	'7':	val+=7;	break;		
			case	'8':	val+=8;	break;		
			case	'9':	val+=9;	break;
			default:	//10ił͖ꍇ
						for(i=0;i<32;i++){
							buf[i]=*(TEXT+i);
						}
						buf[i]=0;
						sprintf(str,"[%s]F10ił͂܂",buf);
						msg(str,"[");
						PostMessage(hwnd,WM_CLOSE,0,0);
						break;
		}

		TEXT++;
		if( *TEXT>' ' && *TEXT!=',' ){
			flag=0;
			val*=10;
		}else{
			flag=1;
		}

	}while( flag==0 );

	val *= fugo;

	return val;
}

//-------------------------------------------
//	eLXg̉́iXy[X+[,]؂Łj
//-------------------------------------------

char *Kaiseki_TextStr()
	//	eLXg當؏o
{
	static char	str[512];
	int			counter,flag;

	//󔒁i߰TABj΂
	while( *TEXT==' ' || *TEXT==0x9 )TEXT++;

	//eLXgRs[
	//IF,or oruCRvorTAB
	counter=0;
	flag=0;
	while(counter<254 && flag==0){
		switch( (unsigned char)*TEXT ){
			case	0x0d:	flag=1;	break;	//[CR]=s			
			case	0x0a:	flag=1;	break;	//[LF]=s 001114
			case	' ':	flag=1;	break;	//SPACE CODE
			case	0x09:	flag=1;	break;	//[TAB]
			case	',':	flag=1;	break;	//[,]
		}
		
		if(flag==0){
			str[counter]=*TEXT;
			counter++;
			TEXT++;
		}
	}

	str[counter]=0;

	return &str[0];
}


//-------------------------------------------
//	eLXg̉́i[CR]؂Łj
//-------------------------------------------

char *Kaiseki_TextStr_CR()
	//	eLXg當؏o
	//	Kaiseki_TextStr()Ƃ̈Ⴂ́A[CR][LF]݂̂؂ƂĈƂB
{
	static char	str[512];
	int			counter,flag;

	//󔒁i߰  TABj΂
	while( *TEXT==' ' || *TEXT==0x9 )TEXT++;

	//eLXgRs[
	//IFs
	counter=0;
	flag=0;
	while(counter<254 && flag==0){
		switch( (unsigned char)*TEXT ){
			case	0x0d:	if( *(TEXT+1)==0x0a )flag=1;			break;	//[CR]=s
			case	0x0a:	if( *(TEXT-1)==0x0d )flag=1;counter--;	break;	//[LF]=s
		}
		
		if(flag==0){
			str[counter]=*TEXT;
			counter++;
			TEXT++;
		}
	}

	str[counter]=0;

	//char	buf[512];
	//sprintf( buf,"[%s]",str);
	//msg( buf,"aaa" );

	//str[counter-1]=0;

	//MessageBox(NULL,(const char *)str,"aaa",MB_OK);

	return &str[0];
}

//----------------------------------------------
//	́u/v̒܂ŃeLXg|C^΂
//----------------------------------------------

int next_slush()
	//́u/v̒܂ŃeLXg|C^΂
{
	int		kakko=0;	//u{vŁ{PAu}vŁ|PJE^ilXg΍j
	int		counter;	//Ƃ肠[vh߂̃JE^i΁j

	while( 1 ){
		if( *TEXT=='/' && *(TEXT-1)<0x80 && kakko==0 )break;
		if( *TEXT=='{' && *(TEXT-1)<0x80 )kakko++;
		if( *TEXT=='}' && *(TEXT-1)<0x80 )kakko--;
		TEXT++;
		counter++;
		if( counter>0xffff ){
			MessageBox(NULL,"T[`dmcB{ }̑ΉρH॥ij","Error",MB_OK);
		}
	}
	TEXT++;

	return 0;
}

//----------------------------------------------
//	{}̃ubN[T
//----------------------------------------------

int jump_to_end_kakko()
	//XNvgubN̏I[u}v̒܂ŃeLXg|C^΂
{
	int		kakko=1;	//u{vŁ{PAu}vŁ|PJE^ilXg΍j
	int		counter;	//Ƃ肠[vh߂̃JE^i΁j

	while( 1 ){
		if( kakko==0 )break;
		if( *TEXT=='{' && *(TEXT-1)<0x80 )kakko++;
		if( *TEXT=='}' && *(TEXT-1)<0x80 )kakko--;
		TEXT++;
		counter++;
		if( counter>0xffff ){
			MessageBox(NULL,"T[`dmcB{ }̑ΉρH॥ij","Error",MB_OK);
		}
	}
	TEXT++;

	return 0;
}


//--------------------------------------------------------
//	R}h̐U蕪
//--------------------------------------------------------

void Command_call()
	//u#vƂł̊֐ĂԂƁAu#v
	//R}h͂Ă̏֐Ăт܂
{
	char	com_name[256];
	int		i=0;
	int		flag=OFF;

	TEXT++;		//#΂

	//R}h̐؂o
	while( *TEXT>0x20 ){
		com_name[i] = *TEXT;
		TEXT++;
		i++;
	}
	TEXT--;
	com_name[i]=0;	//NULL

	//R}h̕]  ֐Ăяo
	if( strcmp(com_name,"delay"   )==0 ){	Com_delay();		flag=ON;}	//x
	if( strcmp(com_name,"wait"    )==0 ){	Com_cursor_blink();	flag=ON;}	//J[\uN
	if( strcmp(com_name,"w"       )==0 ){	Com_cursor_blink();	flag=ON;}	//J[\uN
	if( strcmp(com_name,"halt"    )==0 ){	Com_halt();			flag=ON;}	//I
	if( strcmp(com_name,"page"    )==0 ){	Com_page();			flag=ON;}	//y[W
	if( strcmp(com_name,"g_load"  )==0 ){	Com_g_load();		flag=ON;}	//BMPLOAD
	if( strcmp(com_name,"g_copy"  )==0 ){	Com_g_copy();		flag=ON;}	//BMPCOPY
	if( strcmp(com_name,"g_change")==0 ){	Com_g_change();		flag=ON;}	//ʐؑ
	if( strcmp(com_name,"flag_on" )==0 ){	Com_flag_on();		flag=ON;}	//CxgtOON
	if( strcmp(com_name,"flag_off")==0 ){	Com_flag_off();		flag=ON;}	//CxgtOOFF
	if( strcmp(com_name,"disp_flag")==0 ){	Com_disp_flag();	flag=ON;}	//CxgtOOFF
	if( strcmp(com_name,"if_flag" )==0 ){	Com_if_flag();		flag=ON;}	//tOɂ镪
	if( strcmp(com_name,"jump"    )==0 ){	Com_jump();			flag=ON;}	//xWv
	if( strcmp(com_name,"file_change")==0 ){Com_file_change();	flag=ON;}	//t@CԃWv

	//		
	//̂ɑ̃R}hǉĂ܂傤
	//		


	//tOāA؂oꂽR}hLȃR}hǂmF
	if( flag == OFF ){
		char	str[256];

		sprintf( str,"xFȃR}h [#%s] LqĂ܂",com_name);
		MessageBox(NULL,str,"Command_call()",MB_OK);
	}
}

//--------------------------------------------------------
//	䕶̏
//--------------------------------------------------------

int Check_control_chr()
	//*TEXT ̃|CgPoCg`FbNA
	//䕶łΏ true ԂAȊO
	//false Ԃ
{
	int		i,label_flag;

	switch( *TEXT ){
		case	'#':	Command_call();		//R}hĂ
						TEXT++;
						return true;
		case	0x09:	//TAB	
		case	0x0a:	//LF	
		case	0x0d:	//CR
		case	'{' :
		case	'}' :	return true;		//ȂŖ߂==
		case	'/' :	jump_to_end_kakko();
						return true;
		case	';':	Com_linefeed();		//[;] s
						return true;
		case	'*':	//xɑǂݎ̂Ă
						label_flag=OFF;
						i=0;
						//char	str[256];	//for DEBUG
						do{
							//str[i]=*(TEXT+i);
							if(*(TEXT+i)==':'){
								label_flag=ON;
								i++;
								break;
							}
							if(*(TEXT+i)==' ')break;	//[:]ɏoȂ܂܃Xy[XɒBxł͂Ȃ
							i++;
						}while(i<=32);
						if( label_flag==ON ){
							TEXT+=i;//xǂݎ̂
							//str[i]=0;
							//msg(str,"aaa");
						}
						return true;
				
	}

	return false;	//䕶ɊYȂ  falseԂ
}



//###############################################################
//	TEXTGWiViIC^v^j{̕
//###############################################################

//-------------------------------------
//	GW{̂ˁ
//-------------------------------------
int Text_engine()
{
	//------------------------------------------
	// EFCgȂeLXg\
	//------------------------------------------
	int color1=RGB(150,230,230);	//F
	int color2=RGB( 10, 10, 10);	//eF

	//w莞Ԍo߂ĂȂꍇMainloopɖ߂
	if( HLS_timer_check(TEXT_TIMER,TEXT_WAIT)==false )return 0;	

	HLS_timer_start(&TEXT_TIMER);	//^C}[ăX^[g

	//P\

		if( (unsigned char)(*TEXT)<(unsigned char)0x80  ){

			//Rg[ǂ𔻒fAYȂΉʂɏo
			if( Check_control_chr()==false ){
				ChrPut3D(Back_DC,TEXT_X ,TEXT_Y ,Font_Size,color1,color2,(char *)TEXT,1);
				
				Increment_textp_pos(1);	//\ʒũCNg=1byte
			}
			TEXT++;		//eLXg|C^PoCgi߂
			
		}else{
			//QoCg̏ꍇ͂QoCgo
			ChrPut3D(Back_DC,TEXT_X ,TEXT_Y ,Font_Size,color1,color2,(char *)TEXT,2);
		
			Increment_textp_pos(2);	//\ʒũCNg=2byte

			TEXT+=2;	//eLXg|C^QoCgi߂	
	
		}
		

	return 0;
}



//end of file

